=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut

#BEGIN{
	#use Benchmark::Stopwatch;
	#$sw = Benchmark::Stopwatch->new;
	#$sw->start;
	##$sw->lap("Start...");
#}
#==========================================================
sub ProgramStart {

	eval "use General;";
	eval "use DisplayMgr;";
	eval "use Mewsoft;";
	eval "use SQLlib;";
	eval "use Banners;";
	eval "use ForumLib;";

	&ModLoad("DBI");
	&ModLoad("Time::Local");

	eval "use Time::HiRes qw(gettimeofday);";
	if ($@) {
			$Global{TimeHiRes} = 0;
			$Global{ProgramStartTime} = time;
	}
	else{
			$Global{TimeHiRes} = 1;
			$Global{ProgramStartTime} = eval "Time::HiRes::gettimeofday();";
	}

	&GetForm;
	&Get_Cookies;
	$ScriptURL = &ScriptURL;
	$ScriptURL =~ s|(?<!:)\/+|\/|g;
	
	&Read_Configuration;
	$ScriptURL =~ s|(?<!:)\/+|\/|g;

	srand (time | $$);

	&LoadLangFile($Global{LanguageForumFile});
	&Access_Lock_Status;
	
	&DB_Start;
	&ReadSettings;

	$Global{Read_Classes_Done} = 0;
	$Global{Force_Read_Classes} = 0;

	&LoadCurrentUser;
	&OnlineUsers;
	$Global{TotalViews}++;
	&UpdateSettings(TotalViews=>$Global{TotalViews});

}
#==========================================================
sub AdminProgramStart{

	eval "use Admin;";
	eval "use Mewsoft;";
	eval "use General;";
	eval "use SQLlib;";
	eval "use DisplayMgr;";

	&ModLoad("DBI", "Time::Local");
	
	&GetForm;
	&Get_Cookies;
	$ScriptURL = &ScriptURL;
	$ScriptURL =~ s|(?<!:)\/+|\/|g;

	&Read_Configuration;

	$ScriptURL =~ s|(?<!:)\/+|\/|g;
	
	srand (time | $$);

	eval "use Time::HiRes qw(gettimeofday);";
	if ($@) {
			$Global{TimeHiRes} = 0;
			$Global{ProgramStartTime} = time;
	}
	else{
			$Global{TimeHiRes} = 1;
			$Global{ProgramStartTime} = eval "Time::HiRes::gettimeofday();";
	}

	$Global{Read_Classes_Done} = 0;
	$Global{Force_Read_Classes} = 0;

	&LoadLangFile($Global{LanguageForumFile});
	if (!$Global{Demo_Mode}) {&Check_Admin_Authentication;}
}
#==========================================================
sub AdminProgramStartNoLogin{

	eval "use Admin;";
	eval "use Mewsoft;";
	eval "use General;";
	eval "use SQLlib;";
	eval "use DisplayMgr;";

	&ModLoad("DBI", "Time::Local");

	&GetForm;
	&Get_Cookies;
	$ScriptURL = &ScriptURL;
	$ScriptURL =~ s|(?<!:)\/+|\/|g;

	&Read_Configuration;

	$ScriptURL =~ s|(?<!:)\/+|\/|g;

	srand (time | $$);

	eval "use Time::HiRes qw(gettimeofday);";
	if ($@) {
			$Global{TimeHiRes} = 0;
			$Global{ProgramStartTime} = time;
	}
	else{
			$Global{TimeHiRes} = 1;
			$Global{ProgramStartTime} = eval "Time::HiRes::gettimeofday();";
	}

	$Global{Read_Classes_Done} = 0;
	$Global{Force_Read_Classes} = 0;

	&LoadLangFile($Global{LanguageForumFile});
}
#==========================================================
sub BannerStart {

	eval "use General;";
	eval "use Mewsoft;";
	eval "use SQLlib;";
	eval "use Banners;";

	&ModLoad(	"DBI", "Time::Local"); 

	eval "use Time::HiRes qw(gettimeofday);";
	if ($@) {
			$Global{TimeHiRes} = 0;
			$Global{ProgramStartTime} = time;
	}
	else{
			$Global{TimeHiRes} = 1;
			$Global{ProgramStartTime} = eval "Time::HiRes::gettimeofday();";
	}

	&GetForm;
	&Get_Cookies;
	$ScriptURL = &ScriptURL;
	$ScriptURL =~ s|(?<!:)\/+|\/|g;

	&Read_Configuration;

	$ScriptURL =~ s|(?<!:)\/+|\/|g;

	srand (time | $$);

	&Access_Lock_Status;
	&DB_Start;
	&ReadSettings;
}
#==========================================================
sub ReadConfigurationFile{
my(@All, $K, $V, $Line, %Update);
	
	open (FILE, "$Global{Configuration_File}") || &Exit("Cannot open configuration file $Global{Configuration_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	foreach $Line(@All){
			($K, $V) = split(/\~\=\=\~/ , $Line);
			$V =~ s/\n$//g;
			$V=~ s/\\n/\n/g;
			$Global{$K} = $V;
	}
}
#==========================================================
sub UpdateConfiguration {
my(%Data) = @_;
my(@All, $Key, $Value, $Line, %Config);

	open (FILE, "$Global{Configuration_File}") || &Exit("Cannot read configuration file $Global{Configuration_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	
	undef %Config;

	foreach $Line(@All){
			$Line =~ s/\n$//;
			($Key, $Value) = split(/\~\=\=\~/ , $Line);
			$Value =~ s/\\n/\n/g;
			$Config{$Key} = $Value;
	}

	while (($Key, $Value) = each %Data) {
			$Config{$Key} = $Value;
	}

	if (!&Lock($Global{Configuration_File})) {&Exit("Cannot Lock file, server may be busy, please wait a few seconds and try again.<br> $Global{Configuration_File}: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);}
	open (FILE, ">$Global{Configuration_File}") || &Exit("Cannot write configuration file $Global{Configuration_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	
	foreach $Key (sort {lc($a) cmp lc($b)} keys (%Config)) {
			$Value = $Config{$Key};
			$Value  =~ s/\n/\\n/g;
			print FILE  "$Key~==~$Value\n";
	}

	close(FILE);

	&Unlock($Global{Configuration_File});
}
#==========================================================
sub UpdateSettings {
my (%Data) = @_;
my ($Query, $Value, $Name);
	
	while (($Name, $Value) = each %Data) {
			$Name =  $dbh->quote($Name);
			$Value =  $dbh->quote($Value);
			@Conf = @{$dbh->selectcol_arrayref(qq!SELECT Name FROM ForumConfig WHERE Name=$Name!)};
			if (@Conf) {
					if (@Conf  > 1) {
						$Query = qq!DELETE FROM ForumConfig WHERE Name=$Name!;
						$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
						$Query = qq!INSERT INTO ForumConfig VALUES ($Name, $Value)!;
						$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
					}
					else {
						$Query = qq!UPDATE ForumConfig SET Value=$Value WHERE Name=$Name LIMIT 1!;
						$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
					}
			}
			else
				{
					$Query = qq!INSERT INTO ForumConfig VALUES ($Name, $Value)!;
					$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			}
	}
}
#==========================================================
sub ReadSettings {
my ($Query, $Temp, $sth, $K, $V);
	
	$Query = qq!SELECT * FROM ForumConfig!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	while(($K, $V) = $sth->fetchrow_array) {
			$Global{$K} = $V;
	}
}
#==========================================================
sub LanguagesList {
my ($Language) = @_;
my (@Files, $File);

	undef @Files;
	opendir(Dir, $Global{LanguageDir});
	foreach $File (readdir(Dir)) {
			if (-d "$Global{LanguageDir}/$File" && $File ne "." && $File ne ".." && $File !~ m/^\_/) { 
					push @Files, $File;
			}
    }
	closedir(Dir);
	return @Files;
 }
#==========================================================
sub ThemesList {
my (@Files, $File);

	undef @Files;
	opendir(Dir, "$Global{Data_Dir}/templates");
	foreach $File (readdir(Dir)) {
			if (-d "$Global{Data_Dir}/templates/$File" && $File ne "." && $File ne ".." && $File !~ m/^\_/) { 
					push @Files, $File;
			}
    }
	closedir(Dir);
	return @Files;
 }
#==========================================================
sub  InitializeLanguagePaths{ 

	$Global{LanguageDir} = "$Global{Data_Dir}/language";
	$Global{Lang_Dir} = "$Global{LanguageDir}/$Global{Language}";

	$Global{LanguageForumFile} = "$Global{Lang_Dir}/Forum.pm";
	$Global{LanguageLanguagesFile} = "$Global{Lang_Dir}/Languages.pm";
	$Global{LanguageRegisterFile} = "$Global{Lang_Dir}/Register.pm";
	$Global{LanguageAccountManagerFile} = "$Global{Lang_Dir}/AccountMgr.pm";
	$Global{LanguagePrivMsgsFile} = "$Global{Lang_Dir}/PrivMsgs.pm";
	$Global{LanguageCopyrightFile} = "$Global{Lang_Dir}/Copyright.pm";
	$Global{LanguageTermsOfUseFile} = "$Global{Lang_Dir}/TermsOfUse.pm";
	$Global{LanguagePrivacyPolicyFile} = "$Global{Lang_Dir}/PrivacyPolicy.pm";
	$Global{LanguageAboutUsFile} = "$Global{Lang_Dir}/AboutUs.pm";
	$Global{LanguageAdvertiseFile} = "$Global{Lang_Dir}/Advertise.pm";
	$Global{LanguageContactUsFile} = "$Global{Lang_Dir}/ContactUs.pm";
	$Global{LanguageSetLanguageFile} = "$Global{Lang_Dir}/SetLanguage.pm";
	$Global{LanguageSearchTipsFile} = "$Global{Lang_Dir}/SearchTips.pm";
	$Global{LanguageCustomFile} = "$Global{Lang_Dir}/Custom.pm";
	$Global{LanguageAccessLockFile} = "$Global{Lang_Dir}/AccessLock.pm";
	$Global{LanguageHelpFile} = "$Global{Lang_Dir}/Help.pm";
	$Global{LanguageBannerFile} = "$Global{Lang_Dir}/Banner.pm";
	$Global{CountriesFile} = "$Global{Lang_Dir}/Countries.pm";
	$Global{LanguageCommunityFile} = "$Global{Lang_Dir}/Community.pm";
	$Global{LanguageRssFile} = "$Global{Lang_Dir}/RSS.pm";
	
}
#==========================================================
sub InitializeTemplatesPaths{ 

	$Global{ForumHomepageTemplate} =  "$Global{Template_Dir}/FrontPage.html";
	$Global{ForumBrowseTemplate} =  "$Global{Template_Dir}/ForumBrowse.html";
	$Global{ForumTopicsFormTemplate} =  "$Global{Template_Dir}/TopicsForm.html";
	$Global{AllForumsTemplate} =  "$Global{Template_Dir}/ForumsTree.html";
	$Global{MyPreferencesTemplate} =  "$Global{Template_Dir}/MyPreferences.html";
	$Global{ForumTopicsListTemplate} =  "$Global{Template_Dir}/TopicsList.html";
	$Global{ForumNewTopicTemplate} =  "$Global{Template_Dir}/NewTopic.html";
	$Global{ForumViewTopicTemplate} =  "$Global{Template_Dir}/ViewTopic.html";
	$Global{ForumTopicReviewTemplate} =  "$Global{Template_Dir}/TopicReview.html";
	$Global{ForumNewPostTemplate} =  "$Global{Template_Dir}/NewPost.html";
	$Global{ForumEditPostTemplate} =  "$Global{Template_Dir}/EditPost.html";
	$Global{ForumDeletePostTemplate} =  "$Global{Template_Dir}/DeletePost.html";
	$Global{ForumViewIPTemplate} =  "$Global{Template_Dir}/ViewIP.html";
	$Global{PreviewTopicFormTemplate} =  "$Global{Template_Dir}/PreviewTopicForm.html";
	$Global{PreviewPostFormTemplate} =  "$Global{Template_Dir}/PreviewPostForm.html";
	$Global{ForumSearchTopicsTemplate} =  "$Global{Template_Dir}/SearchTopics.html";
	$Global{ForumViewProfileTemplate} =  "$Global{Template_Dir}/ViewProfile.html";
	$Global{ForumDeleteTopicTemplate} =  "$Global{Template_Dir}/DeleteTopic.html";
	$Global{ForumMoveTopicTemplate} =  "$Global{Template_Dir}/MoveTopic.html";
	$Global{ForumPrintTopicTemplate} =  "$Global{Template_Dir}/PrintTopic.html";
	$Global{AboutMeEditorTemplate} = "$Global{Template_Dir}/AboutMeEditor.html";
	$Global{AboutMeTemplate} = "$Global{Template_Dir}/AboutMe.html";
	$Global{RegisterTemplate} = "$Global{Template_Dir}/Register.html";
	$Global{EditProfileTemplate} = "$Global{Template_Dir}/EditProfile.html";
	$Global{AccountManagerTemplate} = "$Global{Template_Dir}/AccountMgr.html";
	$Global{AccountManagerLoginTemplate} = "$Global{Template_Dir}/AccountLoginForm.html";
	$Global{AccountManagerMainTemplate} = "$Global{Template_Dir}/AcctMgrOverview.html";
	#------------------------------------------------------
	#------------------------------------------------------
	# private messaging templates
	$Global{MyPrivMsgsTemplate} = "$Global{Template_Dir}/MyPrivMsgs.html";
	$Global{PrivMsgTemplate} = "$Global{Template_Dir}/MyPrivMsg.html";
	$Global{PreviewPrivMsgTemplate} = "$Global{Template_Dir}/MyPreviewPrivMsgForm.html";
	$Global{PrintPrivMsgTemplate} = "$Global{Template_Dir}/MyPrintPrivMsg.html";

	$Global{ViewPrivMsgInboxTemplate} = "$Global{Template_Dir}/MyViewPrivMsgInbox.html";
	$Global{ViewPrivMsgOutboxTemplate} = "$Global{Template_Dir}/MyViewPrivMsgOutbox.html";
	$Global{ViewPrivMsgSentboxTemplate} = "$Global{Template_Dir}/MyViewPrivMsgSentbox.html";
	$Global{ViewPrivMsgSavedboxTemplate} = "$Global{Template_Dir}/MyViewPrivMsgSavedbox.html";

	$Global{MyPrivMsgsInboxTemplate} = "$Global{Template_Dir}/MyPrivMsgsInbox.html";
	$Global{MyPrivMsgsOutboxTemplate} = "$Global{Template_Dir}/MyPrivMsgsOutbox.html";
	$Global{MyPrivMsgsSentboxTemplate} = "$Global{Template_Dir}/MyPrivMsgsSentbox.html";
	$Global{MyPrivMsgsSavedboxTemplate} = "$Global{Template_Dir}/MyPrivMsgsSavedbox.html";
	$Global{MyPrivMsgsDraftsboxTemplate} = "$Global{Template_Dir}/MyPrivMsgsDraftsbox.html";
	#------------------------------------------------------
	#------------------------------------------------------
	$Global{BlockListTemplate} = "$Global{Template_Dir}/BlockList.html";
	$Global{Mail_ListsTemplate} = "$Global{Template_Dir}/MailLists.html";
	$Global{AdvertiseTemplate} = "$Global{Template_Dir}/Advertise.html";
	$Global{SearchTemplate} = "$Global{Template_Dir}/Search.html";
	$Global{CopyrightTemplate} = "$Global{Template_Dir}/Copyright.html";
	$Global{TermsOfUseTemplate} = "$Global{Template_Dir}/TermsOfUse.html";
	$Global{PrivacyPolicyTemplate} = "$Global{Template_Dir}/PrivacyPolicy.html";
	$Global{HelpTemplate} = "$Global{Template_Dir}/Help.html";
	$Global{AboutUsTemplate} = "$Global{Template_Dir}/AboutUs.html";
	$Global{SetLanguageTemplate} = "$Global{Template_Dir}/SetLanguage.html";
	$Global{SearchTipsTemplate} = "$Global{Template_Dir}/SearchTips.html";
	$Global{GeneralTemplate} = "$Global{Template_Dir}/General.html";
	$Global{ContactUsTemplate} = "$Global{Template_Dir}/ContactUs.html";
	$Global{ForgotUserIDTemplate} = "$Global{Template_Dir}/ForgotUserID.html";
	$Global{ForgotPasswordTemplate} = "$Global{Template_Dir}/ForgotPassword.html";
	$Global{AdvancedSearchTemplate} = "$Global{Template_Dir}/AdvancedSearch.html";
	$Global{BannerLoginTemplate} = "$Global{Template_Dir}/BannerLogin.html";
	$Global{BannerStatsTemplate} = "$Global{Template_Dir}/BannerStatsForm.html";
	$Global{BannerTemplate} = "$Global{Template_Dir}/Banner.html";
	$Global{CommunityTemplate} = "$Global{Template_Dir}/Community.html";

	$Global{TextEditorTemplate} = "$Global{Template_Dir}/TextEditor.html";
	$Global{MembersTemplate} = "$Global{Template_Dir}/Members.html";
	$Global{FeedRssTemplate} = "$Global{Template_Dir}/FeedRss.html";

	$Global{HtmlEditorTemplate} =  "$Global{Template_Dir}/HtmlEditor.html";
	$Global{HtmlEditorAdminTemplate} =  "$Global{Template_Dir}/HtmlEditorAdmin.html";
	$Global{HTMLEditorFullTemplate} = "$Global{Template_Dir}/HTMLEditorFull.html";

	$Global{HtmlEditorTinyMceTemplate} =  "$Global{Template_Dir}/HtmlEditorTinyMce.html";
	$Global{HtmlEditorAdminTinyMceTemplate} =  "$Global{Template_Dir}/HtmlEditorAdminTinyMce.html";
	$Global{HTMLEditorFullTinyMceTemplate} = "$Global{Template_Dir}/HTMLEditorFullTinyMce.html";

}
#==========================================================
sub ReadGeneralClassesNames {
my ($Line, %Class);

	open (F, "$Global{Data_Dir}/GeneralClasses.pm") || &Exit("Cannot open configuration file $Global{Data_Dir}/GeneralClasses.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Class;
	foreach $Line (<F>){
			$Line =~ s/\n$//g;
			$Line =~ s/\s+//g;
			if (!$Line) {next;}
			$Class{$Line} = 1;
	}
	close(F);
	return keys %Class;
}
#==========================================================
sub ReadSpecialClassesNames{
my ($Line, %Class);

	open (F, "$Global{Data_Dir}/SpecialClasses.pm") || &Exit("Cannot open configuration file $Global{Data_Dir}/SpecialClasses.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Class;
	foreach $Line (<F>){
			$Line =~ s/\n$//g;
			$Line =~ s/\s+//g;
			if (!$Line) {next;}
			$Class{$Line} = 1;
	}
	close(F);
	return keys %Class;
}
#==========================================================
sub Help_Link{
my ($Subject, $URL)=@_;
my ($Out, $Sub, $Width, $Height);

	$Width = $Global{Admin_Help_Window_Width};
	$Height = $Global{Admin_Help_Window_Height};
	$Sub = $Subject;
	$Sub =~ s/\_/ /g;
	
	$Global{Help_URL} = "http://www.mewsoft.com/Help";
	$Out = qq|<a href="javascript:void(0);" onClick="window.open('$Global{Help_URL}/$Subject\.html','Mewsoft_Software_Help','WIDTH=$Width,HEIGHT=$Height,  toolbar=yes, directories=yes,menubar=yes, scrollbars=yes,resizable=yes,left=0,top=0,screenX=0,screenY=0');return false;"  ONMOUSEOVER="window.status=\'Help: $Sub\'; return true;" ONMOUSEOUT=" window.status=\'\'; return true;">What\'s This?</a>|;
	return $Out;
}
#==========================================================
sub Help_Link_HREF{
my ($Subject)=@_;
my ($Out, $Sub, $Width, $Height);
	
	$Width = $Global{Admin_Help_Window_Width};
	$Height = $Global{Admin_Help_Window_Height};
	$Sub = $Subject;
	$Sub =~ s/\_/ /g;
	$Global{Help_URL} = "http://www.mewsoft.com/Help";
#onClick="window.open('$Global{Help_URL}/$Subject\.html','Mewsoft_Software_Help','WIDTH=$Width,HEIGHT=$Height,scrollbars=yes,resizable=yes,left=0,top=0,screenX=0,screenY=0');return false;"  ONMOUSEOVER="window.status='Help: $Sub'; return true;" ONMOUSEOUT=" window.status=''; return true;"
	$Out = qq|onClick="window.open('$Global{Help_URL}/$Subject\.html','Mewsoft_Software_Help','WIDTH=$Width,HEIGHT=$Height, toolbar=yes, directories=yes,menubar=yes, scrollbars=yes,resizable=yes,left=0,top=0,screenX=0,screenY=0');return false;"  ONMOUSEOVER="window.status='Help: $Sub'; return true;" ONMOUSEOUT=" window.status=''; return true;"|;
	return $Out;
}
#==========================================================
sub InitializeThemePaths{
my (@Langs, @Themes, $Line, $Lang, $Theme, %Themes);

	$Global{Default_Language} = $Global{Language};
	
	if ($Cookies{User_Language}) {
			$Global{Language} = $Cookies{User_Language};
			if (!-d "$Global{Data_Dir}/language/$Global{Language}") {
					&Delete_Cookies("User_Language");
					$Global{Language} = $Global{Default_Language};
			}
	}
	elsif ($Param{Lang}) {
		$Global{Language} = $Param{Lang};
	}
	else{
		$Global{Language} ||= "English";
	}

	if (!-d "$Global{Data_Dir}/language/$Global{Language}") {
			&Delete_Cookies("User_Language");
			$Global{Language} = $Global{Default_Language};
			@Langs = &LanguagesList;
			$Global{Language} = $Langs[0];
	}
	
	#$Global{Themes} = "English:Default|Arabic:demo"; # comment this line

	@Themes = split (/\|/, $Global{Themes});
	foreach $Line (@Themes) {
			($Lang, $Theme) = split(/\:/, $Line);
			$Themes{$Lang} = $Theme;
	}

	$Global{Theme} = $Themes{$Global{Language}};

	if (!$Global{Theme}) {
			@Themes = &ThemesList;
			$Global{Theme} = $Themes[0];
	}

	if (!-d "$Global{Data_Dir}/templates/$Global{Theme}") {
			@Themes = &ThemesList;
			$Global{Theme} = $Themes[0];
	}

	#$Global{Language} = "English";
	#p($Global{Theme}, $Global{Language});
}
#==========================================================
sub InitializeTheme{
my (%Custom, $K, $V);

	%Custom = &ReadThemeConfig;
	while (($K, $V) = each %Custom) {
			$Global{$K} = $V;
			$PluginsNames{$K} = "";
	}
}
#==========================================================
#==========================================================
sub Read_Configuration{

	#----------------------------------------------------------
	$Global{Data_Dir} = "$Global{CGI_Dir}/data";
	$Global{Configuration_File} = "$Global{Data_Dir}/SysConfig.pm";
	$Global{Lock_Dir} = "$Global{Data_Dir}/lock";
	$Global{HTML_Dir} = $Global{CGI_Dir};
	#----------------------------------------------------------
	&ReadConfigurationFile;
	#----------------------------------------------------------
	#----------------------------------------------------------
	$Global{HTML_Dir} = $Global{CGI_Dir};
	# remove double slashes from url's
	$Global{CGI_URL} =~ s|(?<!:)\/+|\/|g;
	$Global{HTML_URL} = $Global{CGI_URL};
	#----------------------------------------------------------
	#Build script url dynamically
	#----------------------------------------------------------
	my @parts =split(/\//, $ENV{SCRIPT_NAME});
	my $script = pop (@parts);
	#$ScriptURL = $Global{CGI_URL}."//".$script;
	$ScriptURL =~ s|(?<!:)\/+|\/|g;
	#----------------------------------------------------------
	$Global{Templates_Dir} = "$Global{Data_Dir}/templates";
	$Global{Custom_Dir} = "$Global{Data_Dir}/lib";
	$Global{Mail_Lists_Dir} = "$Global{Data_Dir}/mail";
	$Global{Database_Dir} = "$Global{Data_Dir}/database";
	$Global{Temp_Dir} = "$Global{Data_Dir}/temp";
	$Global{Upload_Dir} = "$Global{HTML_Dir}/upload";
	$Global{Upload_URL} = "$Global{HTML_URL}/upload";
	$Global{Avatars_Dir} = "$Global{HTML_Dir}/avatars";
	$Global{Avatars_URL} = "$Global{HTML_URL}/avatars";
	$Global{Attach_Dir} = "$Global{HTML_Dir}/attach";
	$Global{Attach_URL} = "$Global{HTML_URL}/attach";
	$Global{ImagesLink} = "$Global{HTML_URL}/images";
	#----------------------------------------------------------
	$Global{Software_Version} = "3.64";
	$Global{Software_Build} = "03212012";
	#----------------------------------------------------------
	&InitializeThemePaths;
	&InitializeLanguagePaths;
	#----------------------------------------------------------
	#----------------------------------------------------------
	# Data files
	$Global{Banned_Words_File} = "$Global{Data_Dir}/BannedWords.txt";
	$Global{RegisterOptions_File} = "$Global{Data_Dir}/RegisterOptions.pm";
	$Global{Promotional_Code_File} = "$Global{Data_Dir}/PromotionalCodes.txt";
	$Global{BannedEmail_File} = "$Global{Data_Dir}/BannedEmails.pm";
	$Global{MailLettersFile} = "$Global{Mail_Lists_Dir}/letters.pm";
	$Global{Visitors_Log_File}="$Global{Data_Dir}/logs/forum.log";
	#---------------------------------------------------------------------------------------
	$Global{ProgURL} = "$Global{CGI_URL}/$Global{MainProg}/";
	$Global{AdminURL} = "$Global{CGI_URL}/$Global{AdminProg}/";
	$Global{ProgURL} =~ s|(?<!:)\/+|\/|g;
	$Global{AdminURL} =~ s|(?<!:)\/+|\/|g;

	$Global{BannerStatsURL} = "$Global{CGI_URL}/$Global{BannerStatsProg}";
	$Global{BannerStatsURL} =~ s|(?<!:)\/+|\/|g;

	if ($Global{SSL_Status}) {
		$Global{BannerClickURL} = "$Global{SSL_URL}/$Global{BannerClickProg}";
		$Global{BannerURL} = "$Global{SSL_URL}/$Global{BannerProg}";
	}
	else {
		$Global{BannerClickURL} = "$Global{CGI_URL}/$Global{BannerClickProg}";
		$Global{BannerURL} = "$Global{CGI_URL}/$Global{BannerProg}";
	}
	$Global{BannerClickURL} =~ s|(?<!:)\/+|\/|g;
	$Global{BannerURL} =~ s|(?<!:)\/+|\/|g;
	#---------------------------------------------------------------------------------------
	$Global{Template_Dir} = "$Global{Templates_Dir}/$Global{Theme}";
	$Global{ThemeConfigFile} = "$Global{Template_Dir}/Config.pm";
	$Global{Images}  = "$Global{HTML_URL}/theme/$Global{Theme}";
	$Global{Skins} = "$Global{HTML_URL}/skins";
	$Global{Skin} = "$Global{Skins}/$Global{SkinName}";
	$Global{Update_URL} = "http://www.mewsoft.com/cgi-bin/installer/installer.cgi";
	#---------------------------------------------------------------------------------------
	&InitializeTheme;
	&InitializeTemplatesPaths;
	#---------------------------------------------------------------------------------------
	#---------------------------------------------------------------------------------------
	#&Log_Visitor;
	#---------------------------------------------------------------------------------------
}
#==========================================================
#==========================================================
sub Log_Visitor{
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);
my ($LOG, $Query);

    $Query = "";
	if ($ENV{CONTENT_LENGTH} ) {
				read(STDIN, $Query, $ENV{CONTENT_LENGTH});
    } 
	elsif ($ENV{QUERY_STRING}) {
			$Query = $ENV{QUERY_STRING};
    }

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$mon++;
	$year += 1900;
	
	$LOG = qq!$mday/$mon/$year/$hour:$min:$sec|$ENV{REMOTE_ADDR}|$ScriptURL?$Query|$ENV{HTTP_REFERER}!;
	
	&Lock("$Global{Visitors_Log_File}");
	open(LOG, ">>$Global{Visitors_Log_File}");
	print LOG "$LOG\n";
	close(LOG);
	&Unlock("$Global{Visitors_Log_File}");
}
#==========================================================
1;
