=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Edit_Profile{

	&LoadLangFile($Global{LanguageAccountManagerFile});
	&LoadLangFile($Global{LanguageRegisterFile});
	
	&Check_Account_Login;
	
	$Plugins{Body} = &Edit_Profile_Form;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub Edit_Profile_Form{
my ($Template, %User, %Fields, %EditFields, $Field, $Key, $Subj, $Body);

	$Template =&TranslateFile($Global{EditProfileTemplate});

	undef %User;
	%User = &Get_User($Param{User_ID});

	if ($Global{SSL_Status}){
			$URL = "$Global{SSL_URL}/$Global{MainProg}";
	}
	else{
			$URL = "$Global{CGI_URL}/$Global{MainProg}";
	}
	
	$Template =~ s/<!--Action-->/$URL/;
	$Template =~ s/<!--Language-->/$Global{Language}/;

	#------------------------------------------------------
	$Param{Error} ||= "";
	if ($Param{Error}) {
			$Template =~ s/<!--Errors_Form-->/$Language{Errors_Form}/g;
	}
	$Template =~ s/<!--Error-->/$Param{Error}/;
	#------------------------------------------------------
	$Template =~ s/<!--User_ID-->/$User{User_ID}/g;
	$Template =~ s/<!--Email-->/$User{Email}/g;
	$Template =~ s/<!--NewPassword-->/$User{Password}/g;
	$Template =~ s/<!--PasswordVerify-->/$User{Password}/g;
	#--------------------------------------------------------------------------
	%Fields = &GetRegisterSettings;
	
	%EditFields = %User;
	$EditFields{Agree} = "Agree"; # Agree button
	
	foreach $Field (keys %EditFields) {
			$Key = $Field ."_Form";
			if ($Fields{$Field}{Edit}) {$Value = $Language{$Key};} else {$Value = "";}
			$Template =~ s/<!--$Key-->/$Value/;
			$Template =~ s/<!--$Field-->/$User{$Field}/;

			$Key = $Field ."_Required";
			if ($Fields{$Field}{Required}) {$Value = $Language{required};} else {$Value = "";}
			$Template =~ s/<!--$Key-->/$Value/g;
	}
	if ($Param{Agree}) {$Temp = "checked";} else {$Temp = "";}
	$Template =~ s/<!--AgreeBox-->/$Temp/g;
	#--------------------------------------------------------------------------
	$User{Country} ||= $Global{Default_Item_Country};
	$Key = &Country_List($User{Country});
	$Template =~ s/<!--Country_List-->/$Key/g;
	#--------------------------------------------------------------------------
	return $Template ;
}
#==========================================================
sub Save_Edit_Profile{
my ($Msg, %Fields, $Key, $x, %User, $Status, $Field);

	&LoadLangFile($Global{LanguageAccountManagerFile});
	&LoadLangFile($Global{LanguageRegisterFile});
	&Check_Account_Login;
	&ReadClasses;

	$Msg = "";

	if (!$Param{NewPassword}) {
				$Msg .= $Language{error_valid_password};
	}
	else{
			if (length($Param{NewPassword}) < 4) {
				$Msg .= $Language{error_password_length};
			}
	}

	if (!$Param{PasswordVerify}) {$Msg .= $Language{error_verify_password};}

	if ($Param{NewPassword} &&  $Param{PasswordVerify}) {
			if ($Param{NewPassword} ne  $Param{PasswordVerify}) {
					$Msg .= $Language{error_password_match};
			}
	}
	#------------------------------------------------------------
	%Fields = &GetRegisterSettings;
	#------------------------------------------------------------
	if ($Fields{Email}{Edit} && $Fields{Email}{Required}) {
			if (!$Param{Email}) {
					$Msg .= $Language{error_email};
			}
			else{
					if (! &Check_Email_Address($Param{Email})) {
							$Msg .= $Language{invalid_email};
					}
			}
	}
	#------------------------------------------------------------
	if ($Fields{FName}{Edit} && $Fields{FName}{Required} && !$Param{FName}) {$Msg .= $Language{error_fname};}
	if ($Fields{LName}{Edit} && $Fields{LName}{Required} && !$Param{LName}) {$Msg .= $Language{error_lname};}
	if ($Fields{Company}{Edit} && $Fields{Company}{Required} && !$Param{Company}) {$Msg .= $Language{error_company};}
	if ($Fields{Street}{Edit} && $Fields{Street}{Required} &&!$Param{Street}) {$Msg .= $Language{error_street};}
	if ($Fields{City}{Edit} && $Fields{City}{Required} && !$Param{City}) {$Msg .= $Language{error_city};}
	if ($Fields{State}{Edit} && $Fields{State}{Required} && !$Param{State}) {$Msg .= $Language{error_state};}
	if ($Fields{Zip}{Edit} && $Fields{Zip}{Required} && !$Param{Zip}) {$Msg .= $Language{error_zip};}
	if ($Fields{Country}{Edit} && $Fields{Country}{Country} && !$Param{Country}) {$Msg .= $Language{error_country};}
	if ($Fields{Phone}{Edit} && $Fields{Phone}{Required} && !$Param{Phone}) {$Msg .= $Language{error_phone};}
	if ($Fields{Mobile}{Edit} && $Fields{Mobile}{Required} && !$Param{Mobile}) {$Msg .= $Language{error_mobile};}
	if ($Fields{Fax}{Edit} && $Fields{Fax}{Required} && !$Param{Fax}) {$Msg .= $Language{error_fax};}
	if ($Fields{Website}{Edit} && $Fields{Website}{Required} && !$Param{Website}) {$Msg .= $Language{error_website};}
	if ($Fields{Job_Title}{Edit} && $Fields{Job_Title}{Required} && !$Param{Job_Title}) {$Msg .= $Language{error_job_title};}
	if ($Fields{Agree}{Edit} && $Fields{Agree}{Required} && !$Param{Agree}) {$Msg .= $Language{error_agree};}
	
	for $x (1..20) { #Custom fields
			$Key = "User" . $x;
			if ($Fields{$Key}{Edit} && $Fields{$Key}{Required} && !$Param{$Key}) {
					$Key = "error_user" . $x;
					$Msg .= $Language{$Key};
			}
	}
	#----------------------------------------------------------
	if ($Msg) {
			$Param{Error} =  $Language{error_registration_information} . $Msg;
			&Edit_Profile;
			return;
	}

	$Param{Last_Updated} = &Time(time);
	#------------------------------------------------------------
	#            Save it now
	#------------------------------------------------------------
	undef %User;
	foreach $Field (@User_Fields) {
				if (exists $Param{$Field}) {
						$User{$Field} = $Param{$Field};
				}
	}
	$User{Password} = $Param{NewPassword};

	&Update_User($Param{User_ID}, %User);
	#------------------------------------------------------------
	$Body = &Translate_Classes(&Translate($Language{edit_profile_email_message}));
	$Subj = &Translate_Classes(&Translate($Language{edit_profile_email_subject}));
	$Plugins{Body} = &Translate_Classes(&Translate($Language{edit_profile_message}));

	foreach $Field (keys %User) {
			$Body =~ s/<!--$Field-->/$User{$Field}/g;
			$Subj =~ s/<!--$Field-->/$User{$Field}/g;
			$Plugins{Body} =~ s/<!--$Field-->/$User{$Field}/g;
	}

	#Email($From, $TO, $Subject,   $Message);
	&Email($Global{Billing_Email}, $Param{Email}, $Subj, $Body);

	&Display($Global{AccountManagerTemplate});
}
#==========================================================
1;