=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Help{
my ($Title, $Link, $Out, $Count, $Key);

	&LoadLangFile($Global{LanguageHelpFile});

	$Out = &TranslateFile($Global{HelpTemplate});

	$Plugins{Bar_Action} = $Language{help_menu_label};
	$Plugins{Menu_Bar} = "";

	for $Count (0..100) {
			$Key = qq|<!--Help_Link:$Count-->|;
			$Link = qq!$Global{ProgURL}action=GetHelp&Index=$Count&Lang=$Global{Language}!;
			$Out =~ s/$Key/$Link/g;
	}

	$Plugins{Body} = "";
    &Display($Out, 1);
}
#==========================================================
sub GetHelp{
my ($Lang_File, $Out,$Template);

	$Param{Page} ||= 0;

	$Lang_File = "$Global{Lang_Dir}/Help_". $Param{Page} .".pm";
	if (-e $Lang_File) {
		&LoadLangFile($Lang_File);
	}
	else{
		&Exit("Can not find language file $Lang_File: $!\n" . "<br>Line " . __LINE__ . ", File ". __FILE__);
	}

	$Template = "$Global{Template_Dir}/Help_". $Param{Page} .".html";
	if (-e $Template) {
		$Out = &TranslateFile($Template);
	}
	else{
		&Exit("Can not find template file $Template: $!\n" . "<br>Line " . __LINE__ . ", File ". __FILE__);
	}

	$Plugins{Bar_Action} = $Language{get_help_menu_label};
	$Plugins{Menu_Bar} = "";

	&Display($Out, 1);
}
#==========================================================
sub AboutUs{

	&LoadLangFile($Global{LanguageAboutUsFile});

	$Plugins{Bar_Action} = $Language{about_us_menu_label};
	$Plugins{Menu_Bar} = "";

	$Plugins{Body}="";
    &Display($Global{AboutUsTemplate});
}
#==========================================================
sub Copyright{

	&LoadLangFile($Global{LanguageCopyrightFile});

	$Plugins{Bar_Action} = $Language{copyright_menu_label};
	$Plugins{Menu_Bar} = "";

	$Language{copyright_body}=~ s/<!--Legal_Contact_Email-->/$Global{Legal_Contact_Email}/g;

	$Plugins{Body}="";
    &Display($Global{CopyrightTemplate});

}
#==========================================================
sub Privacy_Policy{

	&LoadLangFile($Global{LanguagePrivacyPolicyFile});

	$Plugins{Bar_Action} = $Language{privacy_menu_label};
	$Plugins{Menu_Bar} = "";

	$Language{privacy_policy_body}=~ s/<!--Legal_Contact_Email-->/$Global{Legal_Contact_Email}/g;

	$Plugins{Body}="";
    &Display($Global{PrivacyPolicyTemplate});
}
#==========================================================
sub Terms_of_Use{

	&LoadLangFile($Global{LanguageTermsOfUseFile});

	$Plugins{Bar_Action} = $Language{terms_or_use_menu_label};
	$Plugins{Menu_Bar} = "";

	$Language{terms_of_use_body}=~ s/<!--Legal_Contact_Email-->/$Global{Legal_Contact_Email}/g;

	$Plugins{Body}="";
    &Display($Global{TermsOfUseTemplate});

}
#==========================================================
sub Set_Language{

	&LoadLangFile($Global{LanguageSetLanguageFile});
	$Plugins{Bar_Action} = $Language{set_language_menu_label};
	$Plugins{Menu_Bar} = "";
	$Plugins{Body} = "";
	&Display(&SetLanguageForm, 1);
}
#==========================================================
sub Set_Current_Language{

	if (-d "$Global{Data_Dir}/language/$Param{Language_Selected}") {
			$Param{Lang} = $Param{Language_Selected};
			$Global{Language} = $Param{Language_Selected};
			&Set_Cookies("User_Language", $Param{Language_Selected}, 1 );
			&InitializeLanguagePaths;
	}
	
	&Set_Language;
}
#==========================================================
sub SetLanguageForm{
my (@Languages, $Template, $Form, $List);

	$Template = &TranslateFile($Global{SetLanguageTemplate});
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;

	@Languages = split(/\|/, $Global{Languages});
	@Forms = (&Translate($Global{SetLanguageForm}), &Translate($Global{SetLanguageForm1}));

	$Counter = 0;
	$Forms = "";
	foreach $Lang (@Languages) {
			$Checked = "";
			if ($Lang eq $Global{Language}) {$Checked="CHECKED";}

			$Form = $Forms[int($Counter %2)];
			$Form =~ s/<!--Language-->/$Lang/;
			$Form =~ s/<!--Language_Name-->/$Lang/;
			$Form =~ s/<!--Checked-->/$Checked/;

			$Counter++;
			$Forms .= $Form;
	}
	
	$Template =~ s/<!--LanguageList-->/$Forms/;

	return $Template;
}
#==========================================================
sub Search_Help{

	&LoadLangFile($Global{LanguageSearchTipsFile});
	$Plugins{Bar_Action} = $Language{bar_advanced_search_help};

	$Plugins{Body}="";
    &Display($Global{SearchTipsTemplate});
}
#==========================================================
sub Advertise{
my ($Template);

	&LoadLangFile($Global{LanguageAdvertiseFile});
	
	$Plugins{Bar_Action} = $Language{advertise_menu_label};
	$Plugins{Menu_Bar} = "";
	
	$Plugins{Body} = "";
	&Display($Global{AdvertiseTemplate});
}
#==========================================================
sub Custom_Page{
my($Sub, $File);

	&LoadLangFile($Global{LanguageCustomFile});

	$Sub = $Param{Sub};
	$File = $Param{File};
	$Filename = qq!$Global{Custom_Dir}/$File\.pm!;
	eval "require $Filename";
	
	$Plugins{Body} = &$Sub($Param{Param});
	
	$Param{Temp} .= ".html" unless ($Param{Temp}=~ m/\./ );

	&Display("$Global{Template_Dir}/$Param{Temp}");
	
}
#==========================================================
sub GetPage{
my ($Lang_File, $Template_File, @Langs, $Lang);
	
	return "" unless $Param{Name};

	$Lang_File = qq!$Global{Data_Dir}/language/$Global{Language}/$Param{Name}\.page\.pm!;
	$Template_File = qq!$Global{Template_Dir}/$Param{Name}\.page\.shtml!;

	&LoadLangFile($Lang_File);
	$Plugins{Body} = "";
	&Display($Template_File);

}
#==========================================================
1;