=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Upload_File{
my ($Filename, $File_Content) = @_;
my (@File_Exts, $File_Ext, $Ext, $Err);
my (@Files_Ext_Allowed, $File_Allowed, $File_Name, $File);
my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks);

	binmode(STDIN);
	binmode(STDOUT);
	binmode(STDERR);

	@File_Exts = split(/\./ , $Filename);
	$File_Ext = pop @File_Exts;
	$File_Ext = lc($File_Ext);

	@File_Name = split(/[\/|\\]/, $Filename); 
	$File = pop @File_Name;
	$File_Name = qq!$Global{Upload_Dir}/$File!;
	if (-e $File_Name) {
			$File_Name = &Get_Random_Upload_Filename($Global{Upload_Dir}, $File);
	}

	$Global{Files_Ext_Allowed}=~ s/\,/ /g;
	@Files_Ext_Allowed = split(/\s+/, $Global{Files_Ext_Allowed});
	$File_Allowed = 0;
	if ($Global{Upload_Any_File}) {
				$File_Allowed = 1;
	}
	else{
				foreach $Ext(@Files_Ext_Allowed) {
						$Ext = lc($Ext);
						$Ext =~ s/\s+//g;
						if ($File_Ext eq $Ext){
								$File_Allowed =1; last;
						}
		      }
	}

	if ($File_Allowed) { 
				open(FILE,">$File_Name")  || &Exit("Can 't write media file $File_Name: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
				binmode FILE;
				print FILE $File_Content; 
				close(FILE); 
				($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat($File_Name);
				$Err = "";
				chmod (0755, $File_Name);
	}
	else{
				# File ext. not allowed to upload
				$Err = $Language{upload_file_type_error};
	}

	if (!$Err) {
			if ($Filename) { 
						$Err = &Check_Uploaded_File($File_Name, $size);
				}
			else {
						$Err = $Language{upload_file_no_name};
						unlink ($File_Name);
			 }
	 }

	$Upload_Error_Msg = "";
	
	return $Err;
}
#==========================================================
sub Check_Uploaded_File{
my($Fname, $Fsize) = @_;
my($Msg) = "";

	$Fsize = int($Fsize/1000);

	if ($Param{Uploaded_User_Count} >= $Global{Max_Upload_Files} ){
				$Msg .= "$Language{error_max_upload_files} <b>$Global{Max_Upload_Files}</b>.<br>";
	}
	
	if ($Fsize > $Global{Max_Upload_File_Size}) {
			$Msg .= "$Language{error_max_upload_file_size} <b>$Global{Max_Upload_File_Size} $Language{kilo_bytes}</b>.<br>";
	}
	
	if ( ( $Fsize + $Param{Uploaded_User_Size}) > $Global{Max_Upload_Size}) {
			$Msg .= "$Language{error_max_total_upload_size} <b>$Global{Max_Upload_Size} $Language{kilo_bytes}</b>.<br>";
	}

	if (!$Msg) {
			@File = split(/[\/|\\]/, $Fname); 
			$File = pop @File;

			if (!$Param{Uploaded_Files}) {
					$Param{Uploaded_Files} .= "$File";
			}
			else{
					$Param{Uploaded_Files} .= "|$File";
			}
			
			$Param{Uploaded_User_Size} ||= 0;
			$Param{Uploaded_User_Size} += $Fsize;

			$Param{Uploaded_User_Count} ||= 0;
			$Param{Uploaded_User_Count}++;
	 }
	else {
			unlink ("$Fname");
	}

	return $Msg;
}
#==========================================================
sub Get_Item_Languages_List{
my($Default) = @_;
my($x, $List, %Options, $Selected);

	%Options = &GetLangFile($Global{LanguageLanguagesFile});
	$List = "";
	$Default ||= $Global{Default_Item_Language};

	if (exists $Options{Any}) {
			$Selected = "";
			if ($x eq $Default) {$Selected = "SELECTED";}
			$List .= qq!<option value="Any" $Selected>$Options{Any}!;
	}

	foreach $x (sort keys %Options) {
			if ($x eq "Any") {next;}
			$Selected = "";
			if ($x eq $Default) {$Selected = "SELECTED";}
			$List .= qq!<option value="$x" $Selected>$Options{$x}!;
	}

	return $List;
}
#==========================================================
sub Get_Item_Regions_List{
my($Default) = shift;
my($x, $List, %Options, $Selected);

	%Options = &GetLangFile($Global{Language_Regions_File});
	$List = "";
	$Default ||= $Global{Default_Item_Region};

	if (exists $Options{Any}) {
			if ("Any" eq $Default) {$Selected = "SELECTED";}
			$List = qq!<option value="Any" $Selected>$Options{Any}!;
	}

	foreach $x (sort keys %Options) {
				if ($x eq "Any") {next;}
				$Selected = "";
				if ($x eq $Default) {$Selected = "SELECTED";}
				$List .= qq!<option value="$x" $Selected>$Options{$x}!;
	}
	
	return $List;
}
#==========================================================
sub Country_List{
my ($Default) = @_;
my ($Country, $Selected, $List, %Countries);

	%Countries = &GetLangFile($Global{CountriesFile});
	$Default ||= "Any";

	$List = "";
	if (exists $Countries{Any}) {
			if ("Any" eq $Default) {$Selected = "SELECTED";}
			$List = qq!<option value="Any" $Selected>$Countries{Any}!;
	}

	foreach $Country(sort  keys %Countries)  {
			if ($Country eq "Any") {next;}
			$Selected = "";
			if ($Country eq $Default) {$Selected="SELECTED";}
			$List .= qq!<option value="$Country" $Selected>$Countries{$Country}!;
	}

	return $List;
}
#==========================================================
sub Add_Seller_Log{
my ($User_ID, $ID) = @_;

	$User_ID = $dbh->quote($User_ID);
	$IP = $ENV{REMOTE_ADDR};
	$IP = $dbh->quote($IP);
	$Time = time;
	#User_ID CHAR(50), Time $INT, IP CHAR(30)
	$Query = qq!INSERT INTO SellerTrack VALUES($User_ID, $ID, $Time, $IP)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	#  Delete old activities
	$Time = time - ($Global{Seller_Max_Limit_Time}* 60);
	$Time = $dbh->quote($Time);
	$Query = qq!DELETE FROM SellerTrack WHERE User_ID=$User_ID AND Time<$Time!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Get_Seller_Log{
my ($User_ID) = @_;
my (%Items, $ID, $Time);

	$Time = time - ($Global{Seller_Max_Limit_Time}* 60);
	$Time = $dbh->quote($Time);

	$User_ID = $dbh->quote($User_ID);
	$Query = qq!SELECT ID, Time FROM SellerTrack WHERE (User_ID=$User_ID AND Time >= $Time) GROUP BY ID ORDER BY Time DESC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Items;
	while (($ID, $Time) = $sth->fetchrow_array){
			$Items{$ID} = $Time;
	}
	$sth->finish;
	return %Items;
}
#==========================================================
sub Check_User_Credit_Cards{
my ($User_ID) = @_;
my ($Query, $sth, $Found);

	$User_ID = $dbh->quote($User_ID);
	$Query = qq!SELECT * FROM Credit_Cards WHERE User_ID=$User_ID!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while ($Temp = $sth->fetchrow_hashref){
			$Found++; last;
	}
	$sth->finish;
	return $Found;
}
#==========================================================
sub Check_Selling_Permissions{
my ($Balance, $Items, %Items);

	if (!&Check_Seller_Permissions($Param{User_ID})) {
			$Plugins{Body} = $Language{must_have_seller_permissions};
			&Display($Global{GeneralTemplate});
			&Quit;
	}
	#----------------------------------------------------------------
	$Balance = &Get_User_Balance($Param{User_ID});
	#----------------------------------------------------------------
	if ($Global{Positive_Balance_For_Selling} > 0) {
			if ($Balance <= $Global{Selling_Positive_Balance}) {
					$Plugins{Body} = $Language{seller_must_have_positive_balance};
					$Plugins{Body} =~ s/<!--Balance-->/$Balance/g;
					$Plugins{Body} =~ s/\[\[currency\]\]/$Language{currency}/g;
					&Display($Global{GeneralTemplate});
					&Quit;
			}
	}
	#----------------------------------------------------------------
	if ($Balance <= $Global{Max_Negative_Balance}) {
					$Plugins{Body} = $Language{max_negative_balance_reached};
					$Plugins{Body} =~ s/<!--Balance-->/$Balance/g;
					$Plugins{Body} =~ s/\[\[currency\]\]/$Language{currency}/g;
					&Display($Global{GeneralTemplate});
					&Quit;
	}
	#----------------------------------------------------------------
	if ($Global{Require_Credit_Card_For_Selling}) {
		if (!&Check_User_Credit_Cards($Param{User_ID})) {
				$Plugins{Body} = $Language{must_have_credit_card_msg};
				$Plugins{Body} =~ s/<!--Seller_Max_Limit-->/$Global{Seller_Max_Limit}/g;
				&Display($Global{GeneralTemplate});
				&Quit;
		}
	}
	#------------------------------------------------------
	#Check for the limit of seller allowed per day
	%Items = &Get_Seller_Log($Param{User_ID});
	$Items = keys %Items;
	if ($Items >= $Global{Seller_Max_Limit}) {
			$Plugins{Body} = $Language{seller_max_limit_msg};
			$Plugins{Body} =~ s/<!--Seller_Max_Limit-->/$Global{Seller_Max_Limit}/g;
			&Display($Global{GeneralTemplate});
			&Quit;
	}
	#------------------------------------------------------

}
#==========================================================
sub Create_Thumbnail{
my ($ID, $Img, $Featured, $Featured1, $Gallery, $Gallery_Img) = @_;
my ($Filename, $File, $srcW,$srcH, $srcID, $srcImage, $Thumb);

	if (!$Img) {return "";}
	$Filename = "$ID\.jpg";
	# $ext=($name =~ m/\.([^\.]+)$/)[0];
	$File = "$Global{Upload_Dir}/$Img";
	
	GD::Image->trueColor(1);

	($srcW, $srcH, $srcID) = imgsize($File);
	
	if ($srcID eq "JPG") {
			open IN, "$File" || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			$srcImage = GD::Image->newFromJpeg(\*IN) || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);
			#$srcImage = GD::Image->newFromJpeg($File) || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);
			close IN;
	}
	elsif ($srcID eq "GIF") {
			open IN, "$File" || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			$srcImage = GD::Image->newFromGif(\*IN) || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);
			close IN;
	}
	elsif ($srcID eq "GIFXX") {
			# Convert the gif file to a png file
			copy("$File",	"$Global{Temp_Dir}");
			system ("$Global{CGI_Dir}/gif2png $Global{Temp_Dir}/$Img"); 
			$File = "$Global{Temp_Dir}/$Img";
			unlink $File;
			$File =~ s/\.gif$/\.png/i;

			if (!-e $File) {return "";	}

			open IN, "$File" || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			$srcImage = GD::Image->newFromPng(\*IN) || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); ;
			close IN;
			unlink $File;
			#open IN, "$File" || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			#$srcImage = GD::Image->newFromGif(\*IN);
	}
	elsif ($srcID eq "PNG") {
			open IN, "$File" || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			$srcImage = GD::Image->newFromPng(\*IN) || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); ;
			close IN;
	}
	elsif ($srcID eq "XBM") {
			open IN, "$File" || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			$srcImage = GD::Image->newFromXbm(\*IN) || &Exit("Can 't read source image file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); ;
			close IN;
	}
	else{
			return "";
	}
		
	$Global{Thumbnail_Width} ||= 1; # Avoid perl crash for zero sized images
	$Global{Thumbnail_Height} ||= 1;
	$Thumb = new GD::Image($Global{Thumbnail_Width}, $Global{Thumbnail_Height}) || &Exit("Can 't create image : $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
	# copyResized(sourceImage,dstX,dstY,srcX,srcY,destW,destH,srcW,srcH)
	$Thumb->copyResized($srcImage, 0, 0, 0, 0, $Global{Thumbnail_Width}, $Global{Thumbnail_Height}, $srcW,$srcH);
	open(NEW, ">$Global{Thumb_Dir}/$Filename") || &Exit("Can 't create image : $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
	binmode(NEW);
	print NEW  $Thumb->jpeg;  # $jpegdata = $image->jpeg([$quality]) , $quality 0-100
	close(NEW);
	chmod (0755, "$Global{Thumb_Dir}/$Filename");

	if ($Featured) { # Featured home page
			undef $Thumb;
			$Global{Homepage_Thumbnail_Width} ||= 1; # Avoid perl crash for zero sized images
			$Global{Homepage_Thumbnail_Height} ||= 1;
			$Thumb = new GD::Image($Global{Homepage_Thumbnail_Width}, $Global{Homepage_Thumbnail_Height}) || &Exit("Can 't create image : $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			# copyResized(sourceImage,dstX,dstY,srcX,srcY,destW,destH,srcW,srcH)
			$Thumb->copyResized($srcImage, 0, 0, 0, 0, $Global{Homepage_Thumbnail_Width}, $Global{Homepage_Thumbnail_Height}, $srcW,$srcH);
			open(NEW,">$Global{Featured_Dir}/$Filename") || &Exit("Can 't create image file $Global{Featured_Dir}/$Filename: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			binmode(NEW);
			print NEW $Thumb->jpeg;
			close(NEW);
			chmod (0755, "$Global{Featured_Dir}/$Filename");
	}

	if ($Featured1) { # Featured category
			undef $Thumb;
			$Global{Category_Thumbnail_Width} ||= 1; # Avoid perl crash for zero sized images
			$Global{Category_Thumbnail_Height} ||= 1;
			$Thumb = new GD::Image($Global{Category_Thumbnail_Width}, $Global{Category_Thumbnail_Height}) || &Exit("Can 't create image : $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			$Thumb->copyResized($srcImage, 0, 0, 0, 0, $Global{Category_Thumbnail_Width}, $Global{Category_Thumbnail_Height}, $srcW,$srcH);
			open(NEW,">$Global{Featured1_Dir}/$Filename") || &Exit("Can 't create image file $Global{Featured1_Dir}/$Filename: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			binmode(NEW);
			print NEW $Thumb->jpeg;
			close(NEW);
			chmod (0755, "$Global{Featured1_Dir}/$Filename");
	}

	if ($Gallery && !$Gallery_Img) { # Gallery items
			undef $Thumb;
			$Global{Gallery_Image_Width} ||= 1; # Avoid perl crash for zero sized images
			$Global{Gallery_Image_Height} ||= 1;
			$Thumb = new GD::Image($Global{Gallery_Image_Width}, $Global{Gallery_Image_Height}) || &Exit("Can 't create image : $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			$Thumb->copyResized($srcImage, 0, 0, 0, 0, $Global{Gallery_Image_Width}, $Global{Gallery_Image_Height}, $srcW,$srcH);
			open(NEW,">$Global{Gallery_Dir}/$Filename") || &Exit("Can 't create image file $Global{Gallery_Dir}/$Filename: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			binmode(NEW);
			print NEW $Thumb->jpeg;
			close(NEW);
			chmod (0755, "$Global{Gallery_Dir}/$Filename");
	}
	undef $Thumb;
	undef $srcImage;
	
	return $Filename;
}
#==========================================================
1;