=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
BEGIN{
	&ModLoad("GD");
	&ModLoad("Digest::MD5 qw(md5_hex)");
}
#==========================================================
sub GetSecurityImage {
my ($PageName) = @_;
my ($Code, $Digest, $File, $ImageLink);
	
	#----------------------------------------------------------------
	#To avoid creating different image when user keeps refreshing
	$Cookies{$PageName} ||= "";
	if ($Cookies{$PageName} ne "") {
		($File, $Time) = split('::', $Cookies{$PageName});
		if (-e "$Global{HTML_Dir}/SecImg/$File\.jpg") {
				$ImageLink = "$Global{HTML_URL}/SecImg/$File\.jpg";
				if ($Global{SSL_Status}) {$ImageLink =~ s/^http:/https:/;}
				return $ImageLink;
		}
	}
	#----------------------------------------------------------------
	while (1) {
			$Code = uc(&GetRandomSecurityNumber);
			$Digest = md5_hex($Code . $Global{Secure_Key});
			$File = "$Global{HTML_Dir}/SecImg/$Digest\.jpg";
			if ($Global{SSL_Status}) {$ImageLink =~ s/^http:/https:/;}
			if (!-e $File) {last;}
	}
	#----------------------------------------------------------------
	&CreateSecurityImage($Code, $File);
	&Set_Cookies($PageName,  $Digest . "::" . time, "");
	#----------------------------------------------------------------
	$ImageLink = "$Global{HTML_URL}/SecImg/$Digest\.jpg";
	#----------------------------------------------------------------
	return $ImageLink;
}
#==========================================================
sub CreateSecurityImage {
my ($Text, $File) = @_;

	$Global{SecurityImageWidth} = 100;
	$Global{SecurityImageHeight} = 22;
	$Global{SecurityImageLineSpacingV} = 8;
	$Global{SecurityImageLineSpacingH} = 8;

	$Image = new GD::Image($Global{SecurityImageWidth}, $Global{SecurityImageHeight}) ;
	#$image->copy($sourceImage,$dstX,$dstY, $srcX,$srcY,$width,$height)

	# allocate some colors
	$white = $Image->colorAllocate(255,255,255);
	$black = $Image->colorAllocate(0,0,0);
	$red = $Image->colorAllocate(&RGBColor("#FF0000"));
	$blue = $Image->colorAllocate(&RGBColor("0000FF"));
	$green1 = $Image->colorAllocate(&RGBColor("#006600"));
	$pink1 = $Image->colorAllocate(&RGBColor("#660099"));
	$pink = $Image->colorAllocate(&RGBColor("#990099"));
	$blue2 = $Image->colorAllocate(&RGBColor("#0000CC"));
	$green = $Image->colorAllocate(&RGBColor("#00FF00"));
	$yellow = $Image->colorAllocate(&RGBColor("#FFFF66"));
	$blue1 = $Image->colorAllocate(&RGBColor("#003366"));
	$gray = $Image->colorAllocate(&RGBColor("#CECECE"));
	$gray1 = $Image->colorAllocate(&RGBColor("#A4A4A4"));

	@Colors = ($black, $red, $blue, $green1, $pink1, $pink, $blue2, $blue1);

	#$Image->rectangle(1,1, $Global{SecurityImageWidth}-2, $Global{SecurityImageHeight}-2, $blue);
	$Image->fill(0,0,$white);

	$Font = GD::Font->Giant ;
	#print $Font->width . ", ". $Font->height;

	if ($Global{SecurityImageLineSpacingV}>0) {
		$Y = $Global{SecurityImageLineSpacingV};
		while ($Y < $Global{SecurityImageHeight}) {
				$Image->line(0, $Y, $Global{SecurityImageWidth}, $Y, $gray);
				$Y += $Global{SecurityImageLineSpacingV};
		}
	}

	if ($Global{SecurityImageLineSpacingH}>0) {
		$X = $Global{SecurityImageLineSpacingH};
		while ($X < $Global{SecurityImageWidth}) {
				$Image->line($X,  0, $X,  $Global{SecurityImageHeight}, $gray);
				$X += $Global{SecurityImageLineSpacingH};
		}
	}

	#for $N(0..6) {
			#$Image->line(int (rand($Global{SecurityImageWidth})),  int (rand($Global{SecurityImageHeight})), int rand ($Global{SecurityImageWidth}),  int rand ($Global{SecurityImageHeight}), $b2);
	#}

	#for $N(0..100) {
	#		$X =  int rand ($Global{SecurityImageWidth});
	#		$Y =  int rand ($Global{SecurityImageHeight});
	#		$Image->setPixel($X, $Y, $gray1);
	#}

	$X =  $Global{SecurityImageWidth} /2 - ($Font->width * length($Text))/2;
	$Y =  $Global{SecurityImageHeight} /2 - ($Font->height)/2;
	
	$Text = uc($Text);
	@Chars = split ("", $Text);
	for $Count (0..$#Chars) {
			$Char = $Chars[$Count];
			$Image->string(gdGiantFont, $X+($Count*12) -8, $Y-3+ int(rand(6)), $Char, $Colors[int(rand($#Colors))]);
	}

	$Image->rectangle(0,0, $Global{SecurityImageWidth}-1, $Global{SecurityImageHeight}-1, $black);

	open(NEW, ">$File")  || &Exit("Error, Can't create file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);;
	binmode(NEW);
	print NEW $Image->jpeg;
	close(NEW);

	chmod (0755, $File);
}
#==========================================================
sub GetRandomSecurityNumber {
my ($x, @C, $P);

   @C = ("a".."n",6..9,"p".."z",1..5);
   $P = "";
   for $x(1..6){ 
        $P .= $C[rand(@C)];
   }
   return(lc($P));
}
#==========================================================
sub HexColor{
my (@rgb) = @_;
	 return sprintf('#%02x%02x%02x', @rgb);
}
#==========================================================
sub RGBColor {
my ($color) = @_;
	# Convert Hex to RGB
	$color =~ m[^#?([a-f0-9]{2})([a-f0-9]{2})([a-f0-9]{2})$]i;
	return (hex($1), hex($2), hex($3));
}
#==========================================================
1;